package com.gic.haoban.manage.service.service.out.impl;

import cn.hutool.core.collection.CollectionUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.Page;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.GICMQClientUtil;
import com.gic.enterprise.api.dto.EnterpriseDTO;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.service.EnterpriseService;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.manage.api.dto.*;
import com.gic.haoban.manage.api.dto.qdto.ClerkSyncQDTO;
import com.gic.haoban.manage.api.enums.AuditType;
import com.gic.haoban.manage.api.enums.BindTypeEnum;
import com.gic.haoban.manage.api.enums.ChannelCodeEnum;
import com.gic.haoban.manage.api.service.AuditApiService;
import com.gic.haoban.manage.api.service.StaffClerkRelationApiService;
import com.gic.haoban.manage.api.service.hm.HmClerkRelationApiService;
import com.gic.haoban.manage.service.config.Config;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanStaffClerkRelationMapper;
import com.gic.haoban.manage.service.entity.MemberClerkChatConfig;
import com.gic.haoban.manage.service.entity.TabHaobanStaff;
import com.gic.haoban.manage.service.entity.TabHaobanStaffClerkBindLog;
import com.gic.haoban.manage.service.entity.TabHaobanStaffClerkRelation;
import com.gic.haoban.manage.service.service.*;
import com.gic.haoban.manage.service.service.hm.HmQrcodeService;
import com.gic.haoban.manage.service.task.RouterConstant;
import com.gic.haoban.task.api.dto.MqMessageQo;
import com.gic.wechat.api.dto.qywx.welcome.QywxExternalcontactDTO;
import com.gic.wechat.api.dto.qywx.welcome.QywxExternalcontactResultDTO;
import com.gic.wechat.api.service.qywx.QywxUserApiService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class StaffClerkRelationApiServiceImpl implements StaffClerkRelationApiService {

    private static final Logger logger = LoggerFactory.getLogger(StaffClerkRelationApiServiceImpl.class);

    @Autowired
    private StaffClerkRelationService staffClerkRelationService;
    @Autowired
    private EnterpriseService enterpriseService;
    @Autowired
    private ClerkService clerkService;
    @Autowired
    private StoreService storeService;
    @Autowired
    private TabHaobanStaffClerkRelationMapper tabHaobanStaffClerkRelationMapper;
    @Autowired
    private AuditApiService auditApiService;
    @Autowired
    private ClerkMainStoreRelatedService clerkMainStoreRelatedService;
    @Autowired
    private StaffClerkBindLogService staffClerkBindLogService;
    @Autowired
    private StaffService staffService;
    @Autowired
    private ExternalClerkRelatedService externalClerkRelatedService;
    @Autowired
    private QywxUserApiService qywxUserApiService;
    @Autowired
    private WxEnterpriseService wxEnterpriseService;
    @Autowired
    private HmClerkRelationApiService hmClerkRelationApiService;
    @Autowired
    private HmQrcodeService hmQrcodeService;
    @Autowired
    private Config config;

    @Override
    public void bindLogMq(String params) {
        logger.info("绑定日志mq:{}", params);
        StaffClerkBindLogInfoDTO infoDTO = JSONObject.parseObject(params, StaffClerkBindLogInfoDTO.class);
        if (null == infoDTO) {
            logger.info("数据不存在");
            return;
        }
        TabHaobanStaffClerkRelation clerkRelation = tabHaobanStaffClerkRelationMapper.selectByPrimaryKey(infoDTO.getRelationId());
        if (null == clerkRelation) {
            logger.info("不存在绑定数据");
            return;
        }
        ClerkDTO clerkDTO = clerkService.getClerkByClerkIdNoStatus(clerkRelation.getClerkId());
        String phoneNumber = "";
        String clerkName = null;
        if (null != clerkDTO) {
            phoneNumber = clerkDTO.getPhoneNumber();
            clerkName = clerkDTO.getClerkName();
        }
        String operClerkId = infoDTO.getOptStaffId();
        clerkDTO = clerkService.getClerkByClerkIdNoStatus(clerkRelation.getClerkId());
        String operName = null;
        if (null != clerkDTO) {
            operName = clerkDTO.getClerkName();
        }
        TabHaobanStaffClerkBindLog enity = new TabHaobanStaffClerkBindLog();
        enity.setClerkId(clerkRelation.getClerkId());
        enity.setChannelCode(infoDTO.getChannelCode());
        enity.setClerkCode(clerkRelation.getClerkCode());
        enity.setCreateTime(new Date());
        enity.setEnterpriseId(clerkRelation.getEnterpriseId());
        enity.setOptStaffId(operClerkId);
        enity.setOperName(operName);
        enity.setOptType(infoDTO.getOptType());
        enity.setStatusFlag(1);
        enity.setStaffId(clerkRelation.getStaffId());
        enity.setWxEnterpriseId(clerkRelation.getWxEnterpriseId());
        enity.setRelationId(infoDTO.getRelationId());
        enity.setClerkPhone(phoneNumber);
        enity.setUpdateTime(new Date());
        enity.setClerkName(clerkName);
        staffClerkBindLogService.insert(enity);
    }

    @Override
    public List<StaffClerkRelationDTO> listBindCode(String enterpriseId, Set<String> clerkCodeList) {
        return staffClerkRelationService.listBindCode(enterpriseId, clerkCodeList);
    }

    @Override
    public List<StaffClerkRelationDTO> listBindCodeByStaffId(List<String> enterpriseIdList, String staffId) {
        return staffClerkRelationService.listBindCodeByStaffId(enterpriseIdList, staffId);
    }

    @Override
    public List<StaffClerkInfoDTO> listBindDetailByStaffId(String staffId) {
        List<StaffClerkRelationDTO> list = staffClerkRelationService.listBindCodeByStaffId(null, staffId);
        if (CollectionUtils.isEmpty(list)) {
            return null;
        }
        List<StaffClerkInfoDTO> infoDTOS = EntityUtil.changeEntityListByJSON(StaffClerkInfoDTO.class, list);

        infoDTOS.forEach(infoDTO -> {
            EnterpriseDTO enterpriseDTO = enterpriseService.getEnterpriseById(infoDTO.getEnterpriseId());
            if (enterpriseDTO != null) {
                infoDTO.setBrandName(enterpriseDTO.getBrandName());
                infoDTO.setEnterpriseName(enterpriseDTO.getEnterpriseName());
            }
            ClerkDTO clerkDTO = clerkService.getClerkByClerkId(infoDTO.getClerkId(), -1);
            if (null != clerkDTO) {
                infoDTO.setClerkPhoneNumber(clerkDTO.getPhoneNumber());
                infoDTO.setClerkName(clerkDTO.getClerkName());
                infoDTO.setClerkCode(clerkDTO.getClerkCode());
            }

            StoreDTO storeDTO = storeService.getStore(infoDTO.getStoreId());
            if (null != storeDTO) {
                infoDTO.setStoreName(storeDTO.getStoreName());
            }
        });
        return infoDTOS;
    }

    @Override
    public ServiceResponse bindStaffClerk(StaffClerkRelationDTO staffClerkRelationDTO, String optStaffId, int channelCode) {
        logger.info("绑定clerk:{}", JSONObject.toJSONString(staffClerkRelationDTO));
        ServiceResponse<Object> response = new ServiceResponse<>();
        StaffClerkRelationDTO relationDTO = staffClerkRelationService.getBindByClerkId(staffClerkRelationDTO.getClerkId(), staffClerkRelationDTO.getWxEnterpriseId());
        if (null != relationDTO) {
            response.setCode(2);
            response.setMessage("已经被绑定，不能绑定");
            return response;
        }
        AuditDTO auditDTO = auditApiService.findByBindRelatedIdAndAuditType(staffClerkRelationDTO.getClerkId(), AuditType.CLERK_BIND.getCode());
        if (null != auditDTO) {
            response.setCode(4);
            response.setMessage("该导购已经被被申请绑定，请审核处理后再绑定");
            return response;
        }
        List<AuditDTO> list = auditApiService.listByStoreId(staffClerkRelationDTO.getStoreId());
        if (CollectionUtils.isNotEmpty(list)) {
            Set<String> staffIds = list.stream().map(AuditDTO::getCommitStaffId).collect(Collectors.toSet());
            if (staffIds.contains(staffClerkRelationDTO.getStaffId())) {
                response.setCode(5);
                response.setMessage("该成员已经已经在该门店下申请了绑定，请审核处理后再绑定");
                return response;
            }
        }
        StaffClerkRelationDTO storeHasBind = staffClerkRelationService.getOneBindByStoreId(staffClerkRelationDTO.getStaffId(), staffClerkRelationDTO.getStoreId());
        if (storeHasBind != null) {
            response.setCode(3);
            response.setMessage("该导购已在该门店下有其它成员绑定");
            return response;
        }

        String relationId = staffClerkRelationService.bind(staffClerkRelationDTO, optStaffId, channelCode);
        response.setResult(relationId);
        return response;
    }

    @Override
    public StaffClerkRelationDTO getByCodeAndEnterpriseId(String clerkCode, String enterpriseId) {
        return staffClerkRelationService.getByCodeAndEnterpriseId(clerkCode, enterpriseId);
    }


    @Override
    public void delBindByStoreId(String wxEnterpriseId,String storeId, String staffId,int channelCode) {
        Set<String> needUnBindStoreIds = new HashSet<>();
        needUnBindStoreIds.add(storeId);
        staffClerkRelationService.delBindByStoreIds(wxEnterpriseId, needUnBindStoreIds, staffId, ChannelCodeEnum.SELF_UNBIND.getCode());
    }

    @Override
    public List<StaffClerkRelationDTO> listByClerkIds(List<String> clerkIds) {
        if (CollectionUtil.isEmpty(clerkIds)) {
            return Collections.EMPTY_LIST;
        }
        return tabHaobanStaffClerkRelationMapper.listByClerkIds(clerkIds);
    }

    @Override
    public List<StaffClerkRelationDTO> listByStoreId(String storeId) {
        List<TabHaobanStaffClerkRelation> list = tabHaobanStaffClerkRelationMapper.listByStoreId(storeId);
        if (CollectionUtil.isEmpty(list)) {
            return new ArrayList<>();
        }
        List<StaffClerkRelationDTO> result = EntityUtil.changeEntityListByJSON(StaffClerkRelationDTO.class, list);
        return result;
    }

    @Override
    public boolean unbindByStaffAndClerkId(String staffId, String clerkId,int channelCode) {
        return staffClerkRelationService.delBind(clerkId, staffId, channelCode);
    }

    @Override
    public StaffClerkRelationDTO getOneByClerkId(String clerkId) {
        TabHaobanStaffClerkRelation tab = tabHaobanStaffClerkRelationMapper.getOneByClerkId(clerkId);
        StaffClerkRelationDTO result = EntityUtil.changeEntityByJSON(StaffClerkRelationDTO.class, tab);
        return result;
    }

    @Override
    public StaffClerkRelationDTO getByClerkId(String clerkId) {
        StaffClerkRelationDTO staffRelation = staffClerkRelationService.getByClerkId(clerkId);
        return staffRelation;
    }

    @Override
    public StaffClerkRelationDTO getByClerkIdForWxUserId(String clerkId) {
        return staffClerkRelationService.getByClerkIdForWxUserId(clerkId);
    }

    @Override
    public StaffClerkRelationDTO getOneByStoreIdAndStaffId(String storeId,
                                                           String staffId) {
        TabHaobanStaffClerkRelation tab = tabHaobanStaffClerkRelationMapper.getOneByStoreIdAndStaffId(storeId, staffId);
        if (tab == null) {
            return null;
        }
        return EntityUtil.changeEntity(StaffClerkRelationDTO.class, tab);
    }

    @Override
    public void delAndInsert(StaffClerkRelationDTO staffClerkRelation, String optStaffId, int channelCode) {
        if (StringUtils.isNotBlank(staffClerkRelation.getStaffClerkRelationId())) {
            TabHaobanStaffClerkRelation oldStaffClerkRelation = tabHaobanStaffClerkRelationMapper.selectByPrimaryKey(staffClerkRelation.getStaffClerkRelationId());
            tabHaobanStaffClerkRelationMapper.delByPrimaryKey(staffClerkRelation.getStaffClerkRelationId());
            staffClerkBindLogService.pushToMq(oldStaffClerkRelation.getStaffId(), optStaffId, BindTypeEnum.UNBIND.getVal(), channelCode, staffClerkRelation.getStaffClerkRelationId());
            clerkMainStoreRelatedService.delMainStore(oldStaffClerkRelation.getStaffId(), oldStaffClerkRelation.getStoreId(), oldStaffClerkRelation.getWxEnterpriseId());
        }
        staffClerkRelationService.bind(staffClerkRelation, optStaffId, channelCode);
    }

    @Override
    public List<StaffClerkRelationDTO> listByEnterpriseIdAndStaffid(String enterpriseId, String staffid) {
        List<TabHaobanStaffClerkRelation> list = tabHaobanStaffClerkRelationMapper.listByEnterpriseIdAndStaffid(enterpriseId, staffid);
        return EntityUtil.changeEntityListByJSON(StaffClerkRelationDTO.class, list);
    }

    @Override
    public Page<StaffClerkBindLogDetailDTO> pageStaffClerkBindLog(String wxEnterpriseId, String search, String enterpriseId, int optType, BasePageInfo pageInfo) {
        Page<StaffClerkBindLogDetailDTO> retList = staffClerkBindLogService.pageBindLog(wxEnterpriseId, enterpriseId, optType, search, pageInfo);
        if (CollectionUtils.isNotEmpty(retList.getResult())) {
            retList.getResult().forEach(item -> {
                TabHaobanStaff haobanStaff = staffService.selectById(item.getStaffId());
                if (null != haobanStaff) {
                    item.setStaffName(haobanStaff.getStaffName());
                    item.setWxUserId(haobanStaff.getWxUserId());
                } else {
                    item.setStaffName("未知成员");
                }
                if ("-1".equals(item.getOptStaffId())) {
                    item.setOptStaffName("系统");
                } else {
                    item.setOptStaffName(item.getOperName());
                }
                if (StringUtils.isBlank(item.getOptStaffName())) {
                    item.setOptStaffName("未知成员");
                }
                if (StringUtils.isBlank(item.getClerkName())) {
                    ClerkDTO clerkDTO = clerkService.getClerkByClerkIdNoStatus(item.getClerkId());
                    if (null != clerkDTO) {
                        item.setClerkName(clerkDTO.getClerkName());
                    }
                }
                item.setClerkPhoneNumber(item.getClerkPhone());
            });
        }
        return retList;
    }

    @Override
    public Page<StaffClerkBindLogDetailDTO> pageStaffClerkUnBindLog(String wxEnterpriseId, String clerkId, String enterpriseId, int optType, BasePageInfo pageInfo) {
        if (wxEnterpriseId == null) {
            logger.info("没有关联企业");
            return null;
        }
        Page<StaffClerkBindLogDetailDTO> retList = staffClerkBindLogService.pageUnBindLog(wxEnterpriseId, clerkId, enterpriseId, optType, pageInfo);
        if (CollectionUtils.isNotEmpty(retList.getResult())) {
            retList.getResult().forEach(item -> {
                TabHaobanStaff haobanStaff = staffService.selectById(item.getStaffId());
                if (null != haobanStaff) {
                    item.setStaffName(haobanStaff.getStaffName());
                    item.setWxUserId(haobanStaff.getWxUserId());
                } else {
                    item.setStaffName("未知成员");
                }
                if ("-1".equals(item.getOptStaffId())) {
                    item.setOptStaffName("系统");
                } else {
                    item.setOptStaffName(item.getOperName());
                }
                if (StringUtils.isBlank(item.getOptStaffName())) {
                    item.setOptStaffName("未知成员");
                }
                if (StringUtils.isBlank(item.getClerkName())) {
                    ClerkDTO clerkDTO = clerkService.getClerkByClerkIdNoStatus(item.getClerkId());
                    if (null != clerkDTO) {
                        item.setClerkName(clerkDTO.getClerkName());
                    }
                }
                item.setClerkPhoneNumber(item.getClerkPhone());
            });
        }
        return retList;
    }

    @Override
    public void pushToBindLog(String staffId, String optStaffId, int optType, int channelCode, String relationId) {
        staffClerkBindLogService.pushToMq(staffId, optStaffId, optType, channelCode, relationId);
    }

    @Override
    public ServiceResponse<String> getClerkMemberChatConfig(String clerkId) {
        ServiceResponse response = new ServiceResponse();
        StaffClerkRelationDTO relationDTO = staffClerkRelationService.getByClerkIdForWxUserId(clerkId);
        if (null == relationDTO) {
            logger.info("导购没有关联企业微信：{}", clerkId);
            response.setCode(2);
            response.setMessage("导购没有关联企业微信");
            return response;
        }

        MemberClerkChatConfig chatConfig = staffClerkRelationService.getChatConfig(relationDTO.getStaffId(), "-1");
        if (chatConfig != null) {
            response.setResult(chatConfig.getConfigId());
            return response;
        }

        QywxExternalcontactDTO send = new QywxExternalcontactDTO();
        send.setType(1);
        send.setScene(1);
        send.setRemark("导购:" + relationDTO.getClerkCode());
        List<String> userIds = new ArrayList<>();
        send.setUser(userIds);

        WxEnterpriseQwDTO qwDTO = this.wxEnterpriseService.getQwInfo(relationDTO.getWxEnterpriseId());
        if (qwDTO.needOpenUserId3th()) {
            userIds.add(relationDTO.getOpenUserId());
        } else {
            userIds.add(relationDTO.getQwUserId());
        }
        QywxExternalcontactResultDTO configResp = qywxUserApiService.addContactWay(qwDTO.getThirdCorpid(), config.getWxSuiteid(), send);
        logger.info("configId:{}", JSON.toJSONString(configResp));
        String configId = configResp.getConfig_id();
        if (StringUtils.isBlank(configId)) {
            logger.info("staff:{}", configId, JSONObject.toJSONString(relationDTO));
            response.setCode(4);
            response.setMessage("创建config失败");
            return response;
        }
        MemberClerkChatConfig clerkChatConfig = new MemberClerkChatConfig();
        clerkChatConfig.setConfigId(configId);
        clerkChatConfig.setEnterpriseId(relationDTO.getEnterpriseId());
        clerkChatConfig.setMemberId("-1");
        clerkChatConfig.setStaffId(relationDTO.getStaffId());
        staffClerkRelationService.saveChatConfig(clerkChatConfig);

        response.setResult(clerkChatConfig.getConfigId());
        return response;
    }

    @Override
    public Page<StaffClerkRelationDTO> pageByWxEnterpriseId(String wxEnterpriseId, BasePageInfo pageInfo) {
        return staffClerkRelationService.pageByWxEnterpriseId(wxEnterpriseId, pageInfo);
    }

    @Override
    public List<StaffClerkRelationDTO> listByStaffId(String wxEnterpriseId, String staffId) {
        return staffClerkRelationService.listByStaffId(wxEnterpriseId, staffId);
    }

    @Override
    public List<StaffClerkRelationDTO> listClerkIdConcatFlagByClerkIds(List<String> clerkIds, String wxEnterpriseId) {
        return staffClerkRelationService.listClerkIdConcatFlagByClerkIds(clerkIds, wxEnterpriseId);
    }

    @Override
    public void clerkStoreMoveDel(String param) {
        logger.info("导购转移删除修改：{}", param);
        if (StringUtils.isBlank(param)) {
            logger.error("参数为空");
            return;
        }
        ClerkSyncQDTO clerkSyncQDTO = JSON.parseObject(param, ClerkSyncQDTO.class);
        Integer type = clerkSyncQDTO.getType();
        String clerkId = clerkSyncQDTO.getClerkId();
        String enterpriseId = clerkSyncQDTO.getEnterpriseId();
        ClerkDTO clerkDTO = clerkService.getClerkByClerkId(clerkId, -1);
        if (clerkDTO == null) {
            logger.error("导购为空");
            return;
        }

        if (type == 1) {
            Integer status = clerkDTO.getStatus();
            logger.info("导购删除解绑,clerkId:{},status:{}", clerkId, status);
            //导购删除解绑
            if (!status.equals(1)) {
                //解绑
                staffClerkRelationService.delBind(clerkId, "-1", ChannelCodeEnum.GIC_CLERK_DEL_UNBIND.getCode());
            }
        } else if (type == 2) {
            logger.info("门店转移、重新绑定,clerkId:{}", clerkId);
            //门店转移、重新绑定
            StaffClerkRelationDTO relationDTO = staffClerkRelationService.getOneBindCodeNoStatus(clerkDTO.getEnterpriseId(), clerkDTO.getClerkCode());
            moveOrAddClerk(clerkSyncQDTO, relationDTO);
        } else if (type == 3) {
            //店长任务重新分配
            Integer clerkType = clerkDTO.getClerkType();
            logger.info("店长任务重新分配,clerkId:{},clerkType:{}", clerkId, clerkType);
            if (clerkType != null && clerkType == 1) {
                //发消息处理新增店长，任务重新分配问题
                try {
                    logger.info("待分配任务重分配======>{}", clerkId);
                    MqMessageQo mqMessageQo = new MqMessageQo();
                    //任务分配给店长
                    mqMessageQo.setType(MqMessageQo.DISTRIBUTE_TASK);
                    mqMessageQo.setData(clerkId);
                    String s = JSONObject.toJSONString(mqMessageQo);
                    GICMQClientUtil.getClientInstance().sendCommonMessage(RouterConstant.ROUTERTYPE, s,
                            "com.gic.haoban.task.api.service.MqAsynApiService", "run");
                } catch (Exception e) {
                    logger.error("任务重新分配问题发送消息队列出错", e);
                }
            }
            hmQrcodeService.updateClerkNameByClerkId(enterpriseId, clerkId, clerkDTO.getClerkName(), clerkDTO.getClerkCode());
        }
    }


    private void moveOrAddClerk(ClerkSyncQDTO clerkSyncQDTO, StaffClerkRelationDTO relationDTO) {
        if (null == relationDTO) {
            logger.info("没有关联导购，不需要新增");
            return;
        }
        //正常的时候
        staffClerkRelationService.delBind(relationDTO.getClerkId(), "-1", ChannelCodeEnum.SYNC_UNBIND.getCode());
        relationDTO.setClerkId(clerkSyncQDTO.getClerkId());
        relationDTO.setStoreId(clerkSyncQDTO.getStoreId());
        ServiceResponse response = bindStaffClerk(relationDTO, "-1", ChannelCodeEnum.SYNC_BIND.getCode());
        logger.info("绑定结果正常：{}，{}", JSONObject.toJSONString(response), relationDTO.getClerkId());
    }

    @Override
    public int getCanAddHmCount(String wxEnterpriseId, String enterpriseId, String clerkId) {
        return this.hmQrcodeService.getCanAddCount(wxEnterpriseId, enterpriseId, clerkId);
    }

    @Override
    public List<String> listStaffIdByWxEnterpriseId(String wxEnterpriseId) {
        return this.staffClerkRelationService.listByWxEnterpriseId(wxEnterpriseId);
    }
}
